/*----- PROTECTED REGION ID(Eds0071.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: Eds0071.cpp,v 1.3 2018-05-28 06:32:52 alessio Exp $";
//=============================================================================
//
// file :        Eds0071.cpp
//
// description : C++ source for the Eds0071 class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Eds0071 are implemented in this file.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.3 $
// $Date: 2018-05-28 06:32:52 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Eds0071.h>
#include <Eds0071Class.h>

#define MAX_DEVSTRING_LENGTH 255

/*----- PROTECTED REGION END -----*/	//	Eds0071.cpp

/**
 *  Eds0071 class description:
 *    
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  Temperature  |  Tango::DevFloat	Scalar
//  Counter      |  Tango::DevULong	Scalar
//  Label        |  Tango::DevString	Scalar
//================================================================

namespace Eds0071_ns
{
/*----- PROTECTED REGION ID(Eds0071::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	Eds0071::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : Eds0071::Eds0071()
 *	Description : Constructors for a Tango device
 *                implementing the classEds0071
 */
//--------------------------------------------------------
Eds0071::Eds0071(Tango::DeviceClass *cl, string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(Eds0071::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Eds0071::constructor_1
}
//--------------------------------------------------------
Eds0071::Eds0071(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(Eds0071::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Eds0071::constructor_2
}
//--------------------------------------------------------
Eds0071::Eds0071(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(Eds0071::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Eds0071::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : Eds0071::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void Eds0071::delete_device()
{
	DEBUG_STREAM << "Eds0071::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(Eds0071::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects
	delete attr_Label_read[0];

	if (dp)
		delete dp;
	
	/*----- PROTECTED REGION END -----*/	//	Eds0071::delete_device
	delete[] attr_Temperature_read;
	delete[] attr_Counter_read;
	delete[] attr_Label_read;
}

//--------------------------------------------------------
/**
 *	Method      : Eds0071::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void Eds0071::init_device()
{
	DEBUG_STREAM << "Eds0071::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(Eds0071::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call
	dp = NULL;
	init_error.clear();
	
	/*----- PROTECTED REGION END -----*/	//	Eds0071::init_device_before
	

	//	Get the device properties from database
	get_device_property();
	
	attr_Temperature_read = new Tango::DevFloat[1];
	attr_Counter_read = new Tango::DevULong[1];
	attr_Label_read = new Tango::DevString[1];
	//	No longer if mandatory property not set. 
	if (mandatoryNotDefined)
		return;

	/*----- PROTECTED REGION ID(Eds0071::init_device) ENABLED START -----*/
	
	//	Initialize device
	try {
		dp = new Tango::DeviceProxy(devicename);

		attrs.push_back(serialnumber + "_Temperature");
		attrs.push_back(serialnumber + "_Counter");
		attrs.push_back(serialnumber + "_Health");
	} catch (Tango::DevFailed &e) {
		set_state(Tango::FAULT);
		init_error = "Initialization failed: " + string(e.errors[0].desc);
	} catch (...) {
		set_state(Tango::FAULT);
		init_error = "Initialization failed: Unknown error";
	}

	attr_Label_read[0] = new char[MAX_DEVSTRING_LENGTH];
	attr_Label_read[0][0] = '\0';
	
	/*----- PROTECTED REGION END -----*/	//	Eds0071::init_device
}

//--------------------------------------------------------
/**
 *	Method      : Eds0071::get_device_property()
 *	Description : Read database to initialize property data members.
 */
//--------------------------------------------------------
void Eds0071::get_device_property()
{
	/*----- PROTECTED REGION ID(Eds0071::get_device_property_before) ENABLED START -----*/
	
	//	Initialize property data members
	
	/*----- PROTECTED REGION END -----*/	//	Eds0071::get_device_property_before

	mandatoryNotDefined = false;

	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("serialnumber"));
	dev_prop.push_back(Tango::DbDatum("devicename"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);
	
		//	get instance on Eds0071Class to get class property
		Tango::DbDatum	def_prop, cl_prop;
		Eds0071Class	*ds_class =
			(static_cast<Eds0071Class *>(get_device_class()));
		int	i = -1;

		//	Try to initialize serialnumber from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  serialnumber;
		else {
			//	Try to initialize serialnumber from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  serialnumber;
		}
		//	And try to extract serialnumber value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  serialnumber;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize devicename from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  devicename;
		else {
			//	Try to initialize devicename from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  devicename;
		}
		//	And try to extract devicename value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  devicename;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

	}

	/*----- PROTECTED REGION ID(Eds0071::get_device_property_after) ENABLED START -----*/
	
	//	Check device property data members init
	
	/*----- PROTECTED REGION END -----*/	//	Eds0071::get_device_property_after
}
//--------------------------------------------------------
/**
 *	Method      : Eds0071::check_mandatory_property()
 *	Description : For mandatory properties check if defined in database.
 */
//--------------------------------------------------------
void Eds0071::check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop)
{
	//	Check if all properties are empty
	if (class_prop.is_empty() && dev_prop.is_empty())
	{
		TangoSys_OMemStream	tms;
		tms << endl <<"Property \'" << dev_prop.name;
		if (Tango::Util::instance()->_UseDb==true)
			tms << "\' is mandatory but not defined in database";
		else
			tms << "\' is mandatory but cannot be defined without database";
		string	status(get_status());
		status += tms.str();
		set_status(status);
		mandatoryNotDefined = true;
		/*----- PROTECTED REGION ID(Eds0071::check_mandatory_property) ENABLED START -----*/
		cerr << tms.str() << " for " << device_name << endl;
		
		/*----- PROTECTED REGION END -----*/	//	Eds0071::check_mandatory_property
	}
}


//--------------------------------------------------------
/**
 *	Method      : Eds0071::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void Eds0071::always_executed_hook()
{
	DEBUG_STREAM << "Eds0071::always_executed_hook()  " << device_name << endl;
	if (mandatoryNotDefined)
	{
		string	status(get_status());
		Tango::Except::throw_exception(
					(const char *)"PROPERTY_NOT_SET",
					status.c_str(),
					(const char *)"Eds0071::always_executed_hook()");
	}
	/*----- PROTECTED REGION ID(Eds0071::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests
	vector<Tango::DeviceAttribute> *devattrs = NULL;
	try {
		devattrs = dp->read_attributes(attrs);
		(*devattrs)[0] >> attr_Temperature_read[0];
		(*devattrs)[1] >> attr_Counter_read[0];

		unsigned short health;
		(*devattrs)[2] >> health;
		switch(health) {
			case 7:
				set_state(Tango::ON);
				set_status("The device is in ON state");
				break;
			default:
				set_state(Tango::FAULT);
				set_status("The device is in FAULT state");
		}

	} catch (Tango::DevFailed &e) {
		set_state(Tango::FAULT);
		set_status(string(e.errors[0].desc));
	} catch (...) {
		set_state(Tango::FAULT);
		set_status("Unknown error");
	}
	if (devattrs)
		delete devattrs;
	
	/*----- PROTECTED REGION END -----*/	//	Eds0071::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : Eds0071::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void Eds0071::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "Eds0071::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Eds0071::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	check_init();
	
	/*----- PROTECTED REGION END -----*/	//	Eds0071::read_attr_hardware
}
//--------------------------------------------------------
/**
 *	Method      : Eds0071::write_attr_hardware()
 *	Description : Hardware writing for attributes
 */
//--------------------------------------------------------
void Eds0071::write_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "Eds0071::write_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Eds0071::write_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Eds0071::write_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute Temperature related method
 *	Description: 
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Eds0071::read_Temperature(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Eds0071::read_Temperature(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Eds0071::read_Temperature) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_Temperature_read);
	
	/*----- PROTECTED REGION END -----*/	//	Eds0071::read_Temperature
}
//--------------------------------------------------------
/**
 *	Read attribute Counter related method
 *	Description: 
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Eds0071::read_Counter(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Eds0071::read_Counter(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Eds0071::read_Counter) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_Counter_read);
	
	/*----- PROTECTED REGION END -----*/	//	Eds0071::read_Counter
}
//--------------------------------------------------------
/**
 *	Read attribute Label related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Eds0071::read_Label(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Eds0071::read_Label(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Eds0071::read_Label) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_Label_read);
	
	/*----- PROTECTED REGION END -----*/	//	Eds0071::read_Label
}
//--------------------------------------------------------
/**
 *	Write attribute Label related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Eds0071::write_Label(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Eds0071::write_Label(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevString	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Eds0071::write_Label) ENABLED START -----*/
	
	check_init();
	
	strncpy(attr_Label_read[0], w_val, MAX_DEVSTRING_LENGTH);
	
	/*----- PROTECTED REGION END -----*/	//	Eds0071::write_Label
}

//--------------------------------------------------------
/**
 *	Method      : Eds0071::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void Eds0071::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(Eds0071::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	Eds0071::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : Eds0071::add_dynamic_commands()
 *	Description : Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void Eds0071::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(Eds0071::add_dynamic_commands) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic commands if any
	
	/*----- PROTECTED REGION END -----*/	//	Eds0071::add_dynamic_commands
}

/*----- PROTECTED REGION ID(Eds0071::namespace_ending) ENABLED START -----*/

//	Additional Methods
void Eds0071::check_init()
{
	if (! init_error.empty())
		Tango::Except::throw_exception( "",
				init_error.c_str(),
				"Eds0071::check_init()");
}

/*----- PROTECTED REGION END -----*/	//	Eds0071::namespace_ending
} //	namespace
