/*----- PROTECTED REGION ID(Eds0071Class.h) ENABLED START -----*/
//=============================================================================
//
// file :        Eds0071Class.h
//
// description : Include for the Eds0071 root class.
//               This class is the singleton class for
//                the Eds0071 device class.
//               It contains all properties and methods which the 
//               Eds0071 requires only once e.g. the commands.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.2 $
// $Date: 2018-05-22 08:22:00 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Eds0071Class_H
#define Eds0071Class_H

#include <tango.h>
#include <Eds0071.h>


/*----- PROTECTED REGION END -----*/	//	Eds0071Class.h


namespace Eds0071_ns
{
/*----- PROTECTED REGION ID(Eds0071Class::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	Eds0071Class::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute Temperature class definition
class TemperatureAttrib: public Tango::Attr
{
public:
	TemperatureAttrib():Attr("Temperature",
			Tango::DEV_FLOAT, Tango::READ) {};
	~TemperatureAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Eds0071 *>(dev))->read_Temperature(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Eds0071 *>(dev))->is_Temperature_allowed(ty);}
};

//	Attribute Counter class definition
class CounterAttrib: public Tango::Attr
{
public:
	CounterAttrib():Attr("Counter",
			Tango::DEV_ULONG, Tango::READ) {};
	~CounterAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Eds0071 *>(dev))->read_Counter(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Eds0071 *>(dev))->is_Counter_allowed(ty);}
};

//	Attribute Label class definition
class LabelAttrib: public Tango::Attr
{
public:
	LabelAttrib():Attr("Label",
			Tango::DEV_STRING, Tango::READ_WRITE) {};
	~LabelAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Eds0071 *>(dev))->read_Label(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Eds0071 *>(dev))->write_Label(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Eds0071 *>(dev))->is_Label_allowed(ty);}
};


/**
 *	The Eds0071Class singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  Eds0071Class : public Tango::DeviceClass
#else
class Eds0071Class : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(Eds0071Class::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Eds0071Class::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static Eds0071Class *init(const char *);
		static Eds0071Class *instance();
		~Eds0071Class();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		Eds0071Class(string &);
		static Eds0071Class *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	Eds0071_H
