/*----- PROTECTED REGION ID(Ows.h) ENABLED START -----*/
//=============================================================================
//
// file :        Ows.h
//
// description : Include file for the Ows class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.6 $
// $Date: 2018-05-22 14:57:17 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Ows_H
#define Ows_H

#include <tango.h>
#include <SnmpClient.h>

/*----- PROTECTED REGION END -----*/	//	Ows.h

/**
 *  Ows class description:
 *    
 */

namespace Ows_ns
{
/*----- PROTECTED REGION ID(Ows::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	Ows::Additional Class Declarations

class Ows : public SnmpClient_ns::SnmpClient
{

/*----- PROTECTED REGION ID(Ows::Data Members) ENABLED START -----*/

//	Add your own data members
	string init_error;
	unsigned int number_of_sensors;
	
	enum device_type { DS18B20, DS2438, EDS0065, EDS0068, EDS0071 };
	struct Sensor {
		unsigned int idx;
		device_type type;
	};
	map<string /* Serial Number */, Sensor> Sensors;

/*----- PROTECTED REGION END -----*/	//	Ows::Data Members

//	Device property data members
public:

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevString	*attr_Firmware_read;
	Tango::DevUShort	*attr_AvailableDevices_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Ows(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Ows(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Ows(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~Ows() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : Ows::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute Firmware related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_Firmware(Tango::Attribute &attr);
	virtual bool is_Firmware_allowed(Tango::AttReqType type);
/**
 *	Attribute AvailableDevices related methods
 *	Description: 
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_AvailableDevices(Tango::Attribute &attr);
	virtual bool is_AvailableDevices_allowed(Tango::AttReqType type);

//	Dynamic attribute methods
public:

	/**
	 *	Attribute PowerSupply related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevUShort
	 *	Attr type:	Scalar
	 */
	virtual void read_PowerSupply(Tango::Attribute &attr);
	virtual bool is_PowerSupply_allowed(Tango::AttReqType type);
	void add_PowerSupply_dynamic_attribute(string attname);
	void remove_PowerSupply_dynamic_attribute(string attname);
	Tango::DevUShort *get_PowerSupply_data_ptr(string &name);
	map<string,Tango::DevUShort>	   PowerSupply_data;

	/**
	 *	Attribute Resolution related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevUShort
	 *	Attr type:	Scalar
	 */
	virtual void read_Resolution(Tango::Attribute &attr);
	virtual bool is_Resolution_allowed(Tango::AttReqType type);
	void add_Resolution_dynamic_attribute(string attname);
	void remove_Resolution_dynamic_attribute(string attname);
	Tango::DevUShort *get_Resolution_data_ptr(string &name);
	map<string,Tango::DevUShort>	   Resolution_data;

	/**
	 *	Attribute Temperature related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Scalar
	 */
	virtual void read_Temperature(Tango::Attribute &attr);
	virtual bool is_Temperature_allowed(Tango::AttReqType type);
	void add_Temperature_dynamic_attribute(string attname);
	void remove_Temperature_dynamic_attribute(string attname);
	Tango::DevFloat *get_Temperature_data_ptr(string &name);
	map<string,Tango::DevFloat>	   Temperature_data;

	/**
	 *	Attribute Humidity related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Scalar
	 */
	virtual void read_Humidity(Tango::Attribute &attr);
	virtual bool is_Humidity_allowed(Tango::AttReqType type);
	void add_Humidity_dynamic_attribute(string attname);
	void remove_Humidity_dynamic_attribute(string attname);
	Tango::DevFloat *get_Humidity_data_ptr(string &name);
	map<string,Tango::DevFloat>	   Humidity_data;

	/**
	 *	Attribute Counter related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevULong
	 *	Attr type:	Scalar
	 */
	virtual void read_Counter(Tango::Attribute &attr);
	virtual bool is_Counter_allowed(Tango::AttReqType type);
	void add_Counter_dynamic_attribute(string attname);
	void remove_Counter_dynamic_attribute(string attname);
	Tango::DevULong *get_Counter_data_ptr(string &name);
	map<string,Tango::DevULong>	   Counter_data;

	/**
	 *	Attribute Pressure related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Scalar
	 */
	virtual void read_Pressure(Tango::Attribute &attr);
	virtual bool is_Pressure_allowed(Tango::AttReqType type);
	void add_Pressure_dynamic_attribute(string attname);
	void remove_Pressure_dynamic_attribute(string attname);
	Tango::DevFloat *get_Pressure_data_ptr(string &name);
	map<string,Tango::DevFloat>	   Pressure_data;

	/**
	 *	Attribute Light related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevULong
	 *	Attr type:	Scalar
	 */
	virtual void read_Light(Tango::Attribute &attr);
	virtual bool is_Light_allowed(Tango::AttReqType type);
	void add_Light_dynamic_attribute(string attname);
	void remove_Light_dynamic_attribute(string attname);
	Tango::DevULong *get_Light_data_ptr(string &name);
	map<string,Tango::DevULong>	   Light_data;

	/**
	 *	Attribute Health related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevUShort
	 *	Attr type:	Scalar
	 */
	virtual void read_Health(Tango::Attribute &attr);
	virtual bool is_Health_allowed(Tango::AttReqType type);
	void add_Health_dynamic_attribute(string attname);
	void remove_Health_dynamic_attribute(string attname);
	Tango::DevUShort *get_Health_data_ptr(string &name);
	map<string,Tango::DevUShort>	   Health_data;

	//--------------------------------------------------------
	/**
	 *	Method      : Ows::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:


	//--------------------------------------------------------
	/**
	 *	Method      : Ows::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(Ows::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes
	void check_init();
	void check_state();

/*----- PROTECTED REGION END -----*/	//	Ows::Additional Method prototypes
};

/*----- PROTECTED REGION ID(Ows::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	Ows::Additional Classes Definitions

}	//	End of namespace

#endif   //	Ows_H
