/*----- PROTECTED REGION ID(OwsClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        OwsClass.h
//
// description : Include for the Ows root class.
//               This class is the singleton class for
//                the Ows device class.
//               It contains all properties and methods which the 
//               Ows requires only once e.g. the commands.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.1 $
// $Date: 2018-05-22 08:06:51 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef OwsClass_H
#define OwsClass_H

#include <SnmpClientClass.h>

// NetSnmp's READ define and Tango's READ clash!
// Undefine the NetSnmp's one
#undef READ

#include <tango.h>
#include <Ows.h>

/*----- PROTECTED REGION END -----*/	//	OwsClass.h


namespace Ows_ns
{
/*----- PROTECTED REGION ID(OwsClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	OwsClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute Firmware class definition
class FirmwareAttrib: public Tango::Attr
{
public:
	FirmwareAttrib():Attr("Firmware",
			Tango::DEV_STRING, Tango::READ) {};
	~FirmwareAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Ows *>(dev))->read_Firmware(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Ows *>(dev))->is_Firmware_allowed(ty);}
};

//	Attribute AvailableDevices class definition
class AvailableDevicesAttrib: public Tango::Attr
{
public:
	AvailableDevicesAttrib():Attr("AvailableDevices",
			Tango::DEV_USHORT, Tango::READ) {};
	~AvailableDevicesAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Ows *>(dev))->read_AvailableDevices(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Ows *>(dev))->is_AvailableDevices_allowed(ty);}
};


//=========================================
//	Define classes for dynamic attributes
//=========================================
//	Attribute PowerSupply class definition
class PowerSupplyAttrib: public Tango::Attr
{
public:
	PowerSupplyAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_USHORT, Tango::READ) {};
	~PowerSupplyAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Ows *>(dev))->read_PowerSupply(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Ows *>(dev))->is_PowerSupply_allowed(ty);}
};

//	Attribute Resolution class definition
class ResolutionAttrib: public Tango::Attr
{
public:
	ResolutionAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_USHORT, Tango::READ) {};
	~ResolutionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Ows *>(dev))->read_Resolution(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Ows *>(dev))->is_Resolution_allowed(ty);}
};

//	Attribute Temperature class definition
class TemperatureAttrib: public Tango::Attr
{
public:
	TemperatureAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_FLOAT, Tango::READ) {};
	~TemperatureAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Ows *>(dev))->read_Temperature(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Ows *>(dev))->is_Temperature_allowed(ty);}
};

//	Attribute Humidity class definition
class HumidityAttrib: public Tango::Attr
{
public:
	HumidityAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_FLOAT, Tango::READ) {};
	~HumidityAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Ows *>(dev))->read_Humidity(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Ows *>(dev))->is_Humidity_allowed(ty);}
};

//	Attribute Counter class definition
class CounterAttrib: public Tango::Attr
{
public:
	CounterAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_ULONG, Tango::READ) {};
	~CounterAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Ows *>(dev))->read_Counter(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Ows *>(dev))->is_Counter_allowed(ty);}
};

//	Attribute Pressure class definition
class PressureAttrib: public Tango::Attr
{
public:
	PressureAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_FLOAT, Tango::READ) {};
	~PressureAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Ows *>(dev))->read_Pressure(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Ows *>(dev))->is_Pressure_allowed(ty);}
};

//	Attribute Light class definition
class LightAttrib: public Tango::Attr
{
public:
	LightAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_ULONG, Tango::READ) {};
	~LightAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Ows *>(dev))->read_Light(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Ows *>(dev))->is_Light_allowed(ty);}
};

//	Attribute Health class definition
class HealthAttrib: public Tango::Attr
{
public:
	HealthAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_USHORT, Tango::READ) {};
	~HealthAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Ows *>(dev))->read_Health(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Ows *>(dev))->is_Health_allowed(ty);}
};


/**
 *	The OwsClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  OwsClass : public SnmpClient_ns::SnmpClientClass
#else
class OwsClass : public SnmpClient_ns::SnmpClientClass
#endif
{
	/*----- PROTECTED REGION ID(OwsClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	OwsClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static OwsClass *init(const char *);
		static OwsClass *instance();
		~OwsClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		OwsClass(string &);
		static OwsClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	Ows_H
