/*----- PROTECTED REGION ID(Ows::DynAttrUtils.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: OwsDynAttrUtils.cpp,v 1.1 2018-05-22 08:06:51 alessio Exp $";
//=============================================================================
//
// file :        OwsDynAttrUtils.cpp
//
// description : Dynamic attributes utilities file for the Ows class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.1 $
// $Date: 2018-05-22 08:06:51 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Ows.h>
#include <OwsClass.h>

/*----- PROTECTED REGION END -----*/	//	Ows::DynAttrUtils.cpp

//================================================================
//  Attributes managed are:
//================================================================
//  PowerSupply  |  Tango::DevUShort	Scalar
//  Resolution   |  Tango::DevUShort	Scalar
//  Temperature  |  Tango::DevFloat	Scalar
//  Humidity     |  Tango::DevFloat	Scalar
//  Counter      |  Tango::DevULong	Scalar
//  Pressure     |  Tango::DevFloat	Scalar
//  Light        |  Tango::DevULong	Scalar
//  Health       |  Tango::DevUShort	Scalar
//================================================================

//	For compatibility reason, this file (OwsDynAttrUtils)
//	manage also the dynamic command utilities.
//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//================================================================

namespace Ows_ns
{
//=============================================================
//	Add/Remove dynamic attribute methods
//=============================================================

//--------------------------------------------------------
/**
 *	Add a PowerSupply dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Ows::add_PowerSupply_dynamic_attribute(string attname)
{
	//	Attribute : PowerSupply
	PowerSupplyAttrib	*powersupply = new PowerSupplyAttrib(attname);
	Tango::UserDefaultAttrProp	powersupply_prop;
	//	description	not set for PowerSupply
	//	label	not set for PowerSupply
	//	unit	not set for PowerSupply
	//	standard_unit	not set for PowerSupply
	//	display_unit	not set for PowerSupply
	//	format	not set for PowerSupply
	//	max_value	not set for PowerSupply
	//	min_value	not set for PowerSupply
	//	max_alarm	not set for PowerSupply
	//	min_alarm	not set for PowerSupply
	//	max_warning	not set for PowerSupply
	//	min_warning	not set for PowerSupply
	//	delta_t	not set for PowerSupply
	//	delta_val	not set for PowerSupply
	
	/*----- PROTECTED REGION ID(Ows::att_PowerSupply_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Ows::att_PowerSupply_dynamic_attribute
	powersupply->set_default_properties(powersupply_prop);
	//	Not Polled
	powersupply->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	PowerSupply_data.insert(make_pair(attname, 0));
	add_attribute(powersupply);
}
//--------------------------------------------------------
/**
 *	remove a PowerSupply dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Ows::remove_PowerSupply_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevUShort>::iterator ite;
    if ((ite=PowerSupply_data.find(attname))!=PowerSupply_data.end())
    {
    	/*----- PROTECTED REGION ID(Ows::remove_PowerSupply_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Ows::remove_PowerSupply_dynamic_attribute
		PowerSupply_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a Resolution dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Ows::add_Resolution_dynamic_attribute(string attname)
{
	//	Attribute : Resolution
	ResolutionAttrib	*resolution = new ResolutionAttrib(attname);
	Tango::UserDefaultAttrProp	resolution_prop;
	//	description	not set for Resolution
	//	label	not set for Resolution
	//	unit	not set for Resolution
	//	standard_unit	not set for Resolution
	//	display_unit	not set for Resolution
	//	format	not set for Resolution
	//	max_value	not set for Resolution
	//	min_value	not set for Resolution
	//	max_alarm	not set for Resolution
	//	min_alarm	not set for Resolution
	//	max_warning	not set for Resolution
	//	min_warning	not set for Resolution
	//	delta_t	not set for Resolution
	//	delta_val	not set for Resolution
	
	/*----- PROTECTED REGION ID(Ows::att_Resolution_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Ows::att_Resolution_dynamic_attribute
	resolution->set_default_properties(resolution_prop);
	//	Not Polled
	resolution->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	Resolution_data.insert(make_pair(attname, 0));
	add_attribute(resolution);
}
//--------------------------------------------------------
/**
 *	remove a Resolution dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Ows::remove_Resolution_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevUShort>::iterator ite;
    if ((ite=Resolution_data.find(attname))!=Resolution_data.end())
    {
    	/*----- PROTECTED REGION ID(Ows::remove_Resolution_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Ows::remove_Resolution_dynamic_attribute
		Resolution_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a Temperature dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Ows::add_Temperature_dynamic_attribute(string attname)
{
	//	Attribute : Temperature
	TemperatureAttrib	*temperature = new TemperatureAttrib(attname);
	Tango::UserDefaultAttrProp	temperature_prop;
	//	description	not set for Temperature
	//	label	not set for Temperature
	//	unit	not set for Temperature
	//	standard_unit	not set for Temperature
	//	display_unit	not set for Temperature
	//	format	not set for Temperature
	//	max_value	not set for Temperature
	//	min_value	not set for Temperature
	//	max_alarm	not set for Temperature
	//	min_alarm	not set for Temperature
	//	max_warning	not set for Temperature
	//	min_warning	not set for Temperature
	//	delta_t	not set for Temperature
	//	delta_val	not set for Temperature
	
	/*----- PROTECTED REGION ID(Ows::att_Temperature_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Ows::att_Temperature_dynamic_attribute
	temperature->set_default_properties(temperature_prop);
	//	Not Polled
	temperature->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	Temperature_data.insert(make_pair(attname, 0.0));
	add_attribute(temperature);
}
//--------------------------------------------------------
/**
 *	remove a Temperature dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Ows::remove_Temperature_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevFloat>::iterator ite;
    if ((ite=Temperature_data.find(attname))!=Temperature_data.end())
    {
    	/*----- PROTECTED REGION ID(Ows::remove_Temperature_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Ows::remove_Temperature_dynamic_attribute
		Temperature_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a Humidity dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Ows::add_Humidity_dynamic_attribute(string attname)
{
	//	Attribute : Humidity
	HumidityAttrib	*humidity = new HumidityAttrib(attname);
	Tango::UserDefaultAttrProp	humidity_prop;
	//	description	not set for Humidity
	//	label	not set for Humidity
	//	unit	not set for Humidity
	//	standard_unit	not set for Humidity
	//	display_unit	not set for Humidity
	//	format	not set for Humidity
	//	max_value	not set for Humidity
	//	min_value	not set for Humidity
	//	max_alarm	not set for Humidity
	//	min_alarm	not set for Humidity
	//	max_warning	not set for Humidity
	//	min_warning	not set for Humidity
	//	delta_t	not set for Humidity
	//	delta_val	not set for Humidity
	
	/*----- PROTECTED REGION ID(Ows::att_Humidity_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Ows::att_Humidity_dynamic_attribute
	humidity->set_default_properties(humidity_prop);
	//	Not Polled
	humidity->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	Humidity_data.insert(make_pair(attname, 0.0));
	add_attribute(humidity);
}
//--------------------------------------------------------
/**
 *	remove a Humidity dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Ows::remove_Humidity_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevFloat>::iterator ite;
    if ((ite=Humidity_data.find(attname))!=Humidity_data.end())
    {
    	/*----- PROTECTED REGION ID(Ows::remove_Humidity_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Ows::remove_Humidity_dynamic_attribute
		Humidity_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a Counter dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Ows::add_Counter_dynamic_attribute(string attname)
{
	//	Attribute : Counter
	CounterAttrib	*counter = new CounterAttrib(attname);
	Tango::UserDefaultAttrProp	counter_prop;
	//	description	not set for Counter
	//	label	not set for Counter
	//	unit	not set for Counter
	//	standard_unit	not set for Counter
	//	display_unit	not set for Counter
	//	format	not set for Counter
	//	max_value	not set for Counter
	//	min_value	not set for Counter
	//	max_alarm	not set for Counter
	//	min_alarm	not set for Counter
	//	max_warning	not set for Counter
	//	min_warning	not set for Counter
	//	delta_t	not set for Counter
	//	delta_val	not set for Counter
	
	/*----- PROTECTED REGION ID(Ows::att_Counter_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Ows::att_Counter_dynamic_attribute
	counter->set_default_properties(counter_prop);
	//	Not Polled
	counter->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	Counter_data.insert(make_pair(attname, 0));
	add_attribute(counter);
}
//--------------------------------------------------------
/**
 *	remove a Counter dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Ows::remove_Counter_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevULong>::iterator ite;
    if ((ite=Counter_data.find(attname))!=Counter_data.end())
    {
    	/*----- PROTECTED REGION ID(Ows::remove_Counter_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Ows::remove_Counter_dynamic_attribute
		Counter_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a Pressure dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Ows::add_Pressure_dynamic_attribute(string attname)
{
	//	Attribute : Pressure
	PressureAttrib	*pressure = new PressureAttrib(attname);
	Tango::UserDefaultAttrProp	pressure_prop;
	//	description	not set for Pressure
	//	label	not set for Pressure
	//	unit	not set for Pressure
	//	standard_unit	not set for Pressure
	//	display_unit	not set for Pressure
	//	format	not set for Pressure
	//	max_value	not set for Pressure
	//	min_value	not set for Pressure
	//	max_alarm	not set for Pressure
	//	min_alarm	not set for Pressure
	//	max_warning	not set for Pressure
	//	min_warning	not set for Pressure
	//	delta_t	not set for Pressure
	//	delta_val	not set for Pressure
	
	/*----- PROTECTED REGION ID(Ows::att_Pressure_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Ows::att_Pressure_dynamic_attribute
	pressure->set_default_properties(pressure_prop);
	//	Not Polled
	pressure->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	Pressure_data.insert(make_pair(attname, 0.0));
	add_attribute(pressure);
}
//--------------------------------------------------------
/**
 *	remove a Pressure dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Ows::remove_Pressure_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevFloat>::iterator ite;
    if ((ite=Pressure_data.find(attname))!=Pressure_data.end())
    {
    	/*----- PROTECTED REGION ID(Ows::remove_Pressure_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Ows::remove_Pressure_dynamic_attribute
		Pressure_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a Light dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Ows::add_Light_dynamic_attribute(string attname)
{
	//	Attribute : Light
	LightAttrib	*light = new LightAttrib(attname);
	Tango::UserDefaultAttrProp	light_prop;
	//	description	not set for Light
	//	label	not set for Light
	//	unit	not set for Light
	//	standard_unit	not set for Light
	//	display_unit	not set for Light
	//	format	not set for Light
	//	max_value	not set for Light
	//	min_value	not set for Light
	//	max_alarm	not set for Light
	//	min_alarm	not set for Light
	//	max_warning	not set for Light
	//	min_warning	not set for Light
	//	delta_t	not set for Light
	//	delta_val	not set for Light
	
	/*----- PROTECTED REGION ID(Ows::att_Light_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Ows::att_Light_dynamic_attribute
	light->set_default_properties(light_prop);
	//	Not Polled
	light->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	Light_data.insert(make_pair(attname, 0));
	add_attribute(light);
}
//--------------------------------------------------------
/**
 *	remove a Light dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Ows::remove_Light_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevULong>::iterator ite;
    if ((ite=Light_data.find(attname))!=Light_data.end())
    {
    	/*----- PROTECTED REGION ID(Ows::remove_Light_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Ows::remove_Light_dynamic_attribute
		Light_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a Health dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Ows::add_Health_dynamic_attribute(string attname)
{
	//	Attribute : Health
	HealthAttrib	*health = new HealthAttrib(attname);
	Tango::UserDefaultAttrProp	health_prop;
	//	description	not set for Health
	//	label	not set for Health
	//	unit	not set for Health
	//	standard_unit	not set for Health
	//	display_unit	not set for Health
	//	format	not set for Health
	//	max_value	not set for Health
	//	min_value	not set for Health
	//	max_alarm	not set for Health
	//	min_alarm	not set for Health
	//	max_warning	not set for Health
	//	min_warning	not set for Health
	//	delta_t	not set for Health
	//	delta_val	not set for Health
	
	/*----- PROTECTED REGION ID(Ows::att_Health_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Ows::att_Health_dynamic_attribute
	health->set_default_properties(health_prop);
	//	Not Polled
	health->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	Health_data.insert(make_pair(attname, 0));
	add_attribute(health);
}
//--------------------------------------------------------
/**
 *	remove a Health dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Ows::remove_Health_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevUShort>::iterator ite;
    if ((ite=Health_data.find(attname))!=Health_data.end())
    {
    	/*----- PROTECTED REGION ID(Ows::remove_Health_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Ows::remove_Health_dynamic_attribute
		Health_data.erase(ite);
	}
}


//============================================================
//	Tool methods to get pointer on attribute data buffer 
//============================================================
//--------------------------------------------------------
/**
 *	Return a pointer on PowerSupply data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevUShort *Ows::get_PowerSupply_data_ptr(string &name)
{
	map<string,Tango::DevUShort>::iterator ite;
    if ((ite=PowerSupply_data.find(name))==PowerSupply_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Ows::get_PowerSupply_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on Resolution data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevUShort *Ows::get_Resolution_data_ptr(string &name)
{
	map<string,Tango::DevUShort>::iterator ite;
    if ((ite=Resolution_data.find(name))==Resolution_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Ows::get_Resolution_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on Temperature data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevFloat *Ows::get_Temperature_data_ptr(string &name)
{
	map<string,Tango::DevFloat>::iterator ite;
    if ((ite=Temperature_data.find(name))==Temperature_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Ows::get_Temperature_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on Humidity data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevFloat *Ows::get_Humidity_data_ptr(string &name)
{
	map<string,Tango::DevFloat>::iterator ite;
    if ((ite=Humidity_data.find(name))==Humidity_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Ows::get_Humidity_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on Counter data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevULong *Ows::get_Counter_data_ptr(string &name)
{
	map<string,Tango::DevULong>::iterator ite;
    if ((ite=Counter_data.find(name))==Counter_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Ows::get_Counter_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on Pressure data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevFloat *Ows::get_Pressure_data_ptr(string &name)
{
	map<string,Tango::DevFloat>::iterator ite;
    if ((ite=Pressure_data.find(name))==Pressure_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Ows::get_Pressure_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on Light data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevULong *Ows::get_Light_data_ptr(string &name)
{
	map<string,Tango::DevULong>::iterator ite;
    if ((ite=Light_data.find(name))==Light_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Ows::get_Light_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on Health data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevUShort *Ows::get_Health_data_ptr(string &name)
{
	map<string,Tango::DevUShort>::iterator ite;
    if ((ite=Health_data.find(name))==Health_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Ows::get_Health_data_ptr()");
    }
	return  &(ite->second);
}


//=============================================================
//	Add/Remove dynamic command methods
//=============================================================


} //	namespace
