/*----- PROTECTED REGION ID(OwsStateMachine.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: OwsStateMachine.cpp,v 1.1 2018-05-22 08:06:51 alessio Exp $";
//=============================================================================
//
// file :        OwsStateMachine.cpp
//
// description : State machine file for the Ows class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.1 $
// $Date: 2018-05-22 08:06:51 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <Ows.h>

/*----- PROTECTED REGION END -----*/	//	Ows::OwsStateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  ON       |  
//  FAULT    |  
//  UNKNOWN  |  
//  ALARM    |  


namespace Ows_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : Ows::is_Firmware_allowed()
 *	Description : Execution allowed for Firmware attribute
 */
//--------------------------------------------------------
bool Ows::is_Firmware_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(Ows::FirmwareStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Ows::FirmwareStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Ows::is_AvailableDevices_allowed()
 *	Description : Execution allowed for AvailableDevices attribute
 */
//--------------------------------------------------------
bool Ows::is_AvailableDevices_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(Ows::AvailableDevicesStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Ows::AvailableDevicesStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Ows::is_PowerSupply_allowed()
 *	Description : Execution allowed for PowerSupply attribute
 */
//--------------------------------------------------------
bool Ows::is_PowerSupply_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(Ows::PowerSupplyStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Ows::PowerSupplyStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Ows::is_Resolution_allowed()
 *	Description : Execution allowed for Resolution attribute
 */
//--------------------------------------------------------
bool Ows::is_Resolution_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(Ows::ResolutionStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Ows::ResolutionStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Ows::is_Temperature_allowed()
 *	Description : Execution allowed for Temperature attribute
 */
//--------------------------------------------------------
bool Ows::is_Temperature_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(Ows::TemperatureStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Ows::TemperatureStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Ows::is_Humidity_allowed()
 *	Description : Execution allowed for Humidity attribute
 */
//--------------------------------------------------------
bool Ows::is_Humidity_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(Ows::HumidityStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Ows::HumidityStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Ows::is_Counter_allowed()
 *	Description : Execution allowed for Counter attribute
 */
//--------------------------------------------------------
bool Ows::is_Counter_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(Ows::CounterStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Ows::CounterStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Ows::is_Pressure_allowed()
 *	Description : Execution allowed for Pressure attribute
 */
//--------------------------------------------------------
bool Ows::is_Pressure_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(Ows::PressureStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Ows::PressureStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Ows::is_Light_allowed()
 *	Description : Execution allowed for Light attribute
 */
//--------------------------------------------------------
bool Ows::is_Light_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(Ows::LightStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Ows::LightStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Ows::is_Health_allowed()
 *	Description : Execution allowed for Health attribute
 */
//--------------------------------------------------------
bool Ows::is_Health_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(Ows::HealthStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Ows::HealthStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================


/*----- PROTECTED REGION ID(Ows::OwsStateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	Ows::OwsStateAllowed.AdditionalMethods

}	//	End of namespace
